/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.PropRole
 *  fire.pb.circletask.PVPMatchTimeConfig
 *  fire.pb.main.ConfigManager
 *  mkdb.Mkdb
 *  mkdb.Procedure
 *  xbean.PvP3QueueRole
 *  xtable.Properties
 *  xtable.Roleid2teamid
 */
package fire.pb.battle.pvp3;

import fire.pb.PropRole;
import fire.pb.battle.pvp3.PPvP3NewBattle;
import fire.pb.battle.pvp3.PvP3Control;
import fire.pb.battle.pvp3.PvP3RaceProxy;
import fire.pb.battle.pvp3.PvP3RoleProxy;
import fire.pb.battle.pvp3.PvP3RoleSingleMatch;
import fire.pb.battle.pvp3.SPvP3MatchResult;
import fire.pb.battle.pvp3.SPvP3ReadyFight;
import fire.pb.circletask.PVPMatchTimeConfig;
import fire.pb.main.ConfigManager;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.concurrent.TimeUnit;
import mkdb.Mkdb;
import mkdb.Procedure;
import xbean.PvP3QueueRole;
import xtable.Properties;
import xtable.Roleid2teamid;

public class PPvP3PairBattleFromQueue
extends Procedure {
    private final int grade;
    public Map<Integer, PVPMatchTimeConfig> matchConfs = ConfigManager.getInstance().getConf(PVPMatchTimeConfig.class);

    public PPvP3PairBattleFromQueue(int grade) {
        this.grade = grade;
    }

    protected boolean process() {
        PvP3RaceProxy race = PvP3RaceProxy.getPvP3RaceProxy(this.grade);
        if (race.getXRace() == null) {
            return false;
        }
        if (!race.isOpening()) {
            return false;
        }
        if (race.getXRace().getWaitingqueue().size() < 2) {
            return false;
        }
        long now = System.currentTimeMillis();
        ArrayList<PvP3RoleProxy> pvpRoleProxys = new ArrayList<PvP3RoleProxy>();
        Iterator it = race.getXRace().getWaitingqueue().iterator();
        while (it.hasNext()) {
            PvP3QueueRole queueRole = (PvP3QueueRole)it.next();
            PvP3RoleProxy pvpRoleProxy = PPvP3PairBattleFromQueue.getValidRole(race, queueRole.getRoleid(), now);
            if (pvpRoleProxy == null) {
                it.remove();
                PvP3RoleProxy.setTeamMemberPvPState(queueRole.getRoleid(), 0);
                PvP3RoleProxy.notifyTeamProtocol(queueRole.getRoleid(), new SPvP3ReadyFight(0));
                continue;
            }
            pvpRoleProxys.add(pvpRoleProxy);
        }
        int queueSize = pvpRoleProxys.size();
        int pairNum = this.selectPair(race, pvpRoleProxys, 0, 0, now);
        if (PvP3Control.getLogger().isInfoEnabled()) {
            PvP3Control.getLogger().info((Object)("PVP3::[PPvP3PairBattleFromQueue] pair end. grade:" + this.grade + " queueSize:" + queueSize + " pairNum:" + pairNum + " roleNum:" + race.getXRace().getAllrolesid().size() + " rankNum:" + race.getXRace().getAllroles().size()));
        }
        return true;
    }

    private static PvP3RoleProxy getValidRole(PvP3RaceProxy race, long roleId, long now) {
        PvP3RoleProxy pvpRoleProxy = null;
        List<Long> roleIds = PvP3RoleProxy.getTeamMemberIds(roleId);
        for (long id : roleIds) {
            PvP3RoleProxy tempPvpRoleProxy = PvP3RoleProxy.getPvP3RoleProxy(id, true);
            if (!race.roleIsCanReady(tempPvpRoleProxy.getRoleId(), false)) {
                return null;
            }
            if (tempPvpRoleProxy.getRoleId() != roleId) continue;
            pvpRoleProxy = tempPvpRoleProxy;
        }
        return pvpRoleProxy;
    }

    private int selectPair(PvP3RaceProxy race, List<PvP3RoleProxy> pvpRoleProxys, int startIndex, int pairNum, long now) {
        int size = race.getXRace().getWaitingqueue().size();
        if (startIndex >= size - 1) {
            return pairNum;
        }
        PvP3QueueRole hostRole = (PvP3QueueRole)race.getXRace().getWaitingqueue().get(startIndex);
        PvP3RoleProxy pvpHostRole = pvpRoleProxys.get(startIndex);
        if (!PPvP3PairBattleFromQueue.roleCanFight(pvpHostRole, now)) {
            return this.selectPair(race, pvpRoleProxys, startIndex + 1, pairNum, now);
        }
        long waitingTime = Math.max(0L, now - hostRole.getEnterqueuetime());
        for (int i = startIndex + 1; i < size; ++i) {
            PvP3RoleProxy pvpGuestRole = pvpRoleProxys.get(i);
            if (!PPvP3PairBattleFromQueue.roleCanFight(pvpGuestRole, now) || !this.pair(pvpHostRole, pvpGuestRole, waitingTime)) continue;
            race.getXRace().getWaitingqueue().remove(startIndex);
            pvpRoleProxys.remove(startIndex);
            race.getXRace().getWaitingqueue().remove(i - 1);
            pvpRoleProxys.remove(i - 1);
            PPvP3PairBattleFromQueue.sendMatchResult(pvpHostRole.getRoleId(), pvpGuestRole.getRoleId());
            PPvP3PairBattleFromQueue.sendMatchResult(pvpGuestRole.getRoleId(), pvpHostRole.getRoleId());
            PPvP3PairBattleFromQueue.NewBattle(this.grade, pvpHostRole.getRoleId(), pvpGuestRole.getRoleId(), now);
            return this.selectPair(race, pvpRoleProxys, startIndex, pairNum + 1, now);
        }
        return this.selectPair(race, pvpRoleProxys, startIndex + 1, pairNum, now);
    }

    private boolean pair(PvP3RoleProxy pvpHostRole, PvP3RoleProxy pvpGuestRole, long waitingTime) {
        if (pvpHostRole.getRoleId() == pvpGuestRole.getRoleId()) {
            return false;
        }
        int hostLevel = pvpHostRole.getScoreLevel();
        int guestLevel = pvpGuestRole.getScoreLevel();
        int seconds = (int)(waitingTime / 1000L) + 1;
        int levelmod = 999;
        PVPMatchTimeConfig conf = this.matchConfs.get(seconds);
        if (conf != null) {
            levelmod = conf.lev;
        }
        int hostRoleLv = Properties.selectLevel((Long)pvpHostRole.getRoleId());
        int guestRoleLv = Properties.selectLevel((Long)pvpGuestRole.getRoleId());
        return Math.abs(hostLevel - guestLevel) + Math.abs(hostRoleLv - guestRoleLv) / 5 <= levelmod;
    }

    public static boolean roleCanFight(PvP3RoleProxy pvpRoleProxy, long now) {
        return now - pvpRoleProxy.getLastBattleTime() >= 5000L;
    }

    public static void sendMatchResult(long roleId, long targetId) {
        List<Long> targetRoleIds = PvP3RoleProxy.getTeamMemberIds(targetId);
        SPvP3MatchResult send = new SPvP3MatchResult();
        for (long id : targetRoleIds) {
            PropRole targetAttr = new PropRole(id, true);
            PvP3RoleSingleMatch targetInfo = new PvP3RoleSingleMatch();
            targetInfo.roleid = id;
            targetInfo.level = (short)targetAttr.getLevel();
            targetInfo.shape = targetAttr.getShape();
            targetInfo.school = targetAttr.getSchool();
            send.targets.add(targetInfo);
        }
        PvP3RoleProxy.notifyTeamProtocol(roleId, send);
    }

    private static void NewBattle(final int grade, final long hostRoleId, final long guestRoleId, final long now) {
        final List<Long> hostTeamMemberIds = PvP3RoleProxy.getTeamMemberIds(hostRoleId);
        final List<Long> guestTeamMemberIds = PvP3RoleProxy.getTeamMemberIds(guestRoleId);
        PvP3RoleProxy.setTeamMemberPvPState(hostRoleId, 2);
        PvP3RoleProxy.setTeamMemberPvPState(guestRoleId, 2);
        Procedure.pexecuteWhileCommit((Procedure)new Procedure(){

            public boolean process() {
                Mkdb.executor().schedule(new Runnable(){

                    @Override
                    public void run() {
                        new Procedure(){

                            public boolean process() {
                                List<Long> roleIds;
                                boolean valid = true;
                                PvP3RaceProxy race = PvP3RaceProxy.getPvP3RaceProxy(grade);
                                if (race.getXRace() == null) {
                                    valid = false;
                                }
                                HashSet<Long> roleIdSet = new HashSet<Long>();
                                if (valid) {
                                    roleIds = PvP3RoleProxy.getTeamMemberIds(hostRoleId);
                                    if (roleIds.size() > 3 || roleIds.size() != hostTeamMemberIds.size() || !roleIds.containsAll(hostTeamMemberIds)) {
                                        valid = false;
                                    }
                                    roleIdSet.addAll(roleIds);
                                }
                                if (valid) {
                                    roleIds = PvP3RoleProxy.getTeamMemberIds(guestRoleId);
                                    if (roleIds.size() > 3 || roleIds.size() != guestTeamMemberIds.size() || !roleIds.containsAll(guestTeamMemberIds)) {
                                        valid = false;
                                    }
                                    for (long id : roleIds) {
                                        if (!roleIdSet.contains(id)) continue;
                                        valid = false;
                                        break;
                                    }
                                }
                                if (valid && PPvP3PairBattleFromQueue.getValidRole(race, hostRoleId, now) == null) {
                                    valid = false;
                                }
                                if (valid && PPvP3PairBattleFromQueue.getValidRole(race, hostRoleId, now) == null) {
                                    valid = false;
                                }
                                if (valid) {
                                    Long tempGuestTeamId;
                                    long hostTeamId = -1L;
                                    long guestTeamId = -1L;
                                    Long tempHostTeamId = Roleid2teamid.select((Long)hostRoleId);
                                    if (tempHostTeamId != null) {
                                        hostTeamId = tempHostTeamId;
                                    }
                                    if ((tempGuestTeamId = Roleid2teamid.select((Long)guestRoleId)) != null) {
                                        guestTeamId = tempGuestTeamId;
                                    }
                                    Procedure.pexecuteWhileCommit((Procedure)new PPvP3NewBattle(grade, hostRoleId, guestRoleId, hostTeamId, guestTeamId));
                                } else {
                                    PvP3RoleProxy.notifyTeamProtocol(hostRoleId, new SPvP3ReadyFight(0));
                                    PvP3RoleProxy.notifyTeamProtocol(guestRoleId, new SPvP3ReadyFight(0));
                                    PvP3RoleProxy.setTeamMemberPvPState(hostRoleId, 0);
                                    PvP3RoleProxy.setTeamMemberPvPState(guestRoleId, 0);
                                }
                                return true;
                            }
                        }.submit();
                    }
                }, 3L, TimeUnit.SECONDS);
                return true;
            }
        });
    }
}

